//----------------------------------------------------------------------------
// dateed.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: dateed.pas
//----------------------------------------------------------------------------
#ifndef dateedHPP
#define dateedHPP
//----------------------------------------------------------------------------
#include <DBCtrls.hpp>
#include <IniFiles.hpp>
#include <Grids.hpp>
#include <consts.hpp>
#include <DB.hpp>
#include <DBTables.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
#include <StdCtrls.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <ExtCtrls.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Dateed
{
//-- type declarations -------------------------------------------------------
enum TDateOrder { doMDY, doDMY, doYMD };

typedef Word TDaysInMonth[12];

typedef TDaysInMonth *PDaysInMonth;

struct TWMDateEdCalClose
{
	Cardinal Msg;
	HWND FocusedWnd;
	long Unused;
	long Result;
} ;

enum TCalPosition { posAbove, posBelow, posLeft, posRight, posOnTop };

enum TStartOfWeek { daySu, dayMo, dayTu, dayWe, dayTh, dayFr, daySa };

enum TSpinDaysIncr { iOneDay, iTwoDays, iThreeDays, iOneWeek, iTwoWeek, iOneMonth, iQuarterYear, iHalfYear, 
	iOneYear };

class __declspec(delphiclass) TCalWB;
class __declspec(pascalimplementation) TCalWB : public Grids::TCustomGrid
{
	typedef Grids::TCustomGrid inherited;
	
private:
	bool FWeekEndSel;
	bool FCalWeek;
	Graphics::TColor FCalWeekColor;
	System::TDateTime FDate;
	int FMonthOffset;
	Classes::TNotifyEvent FOnChange;
	Graphics::TColor FSundayColor;
	Graphics::TColor FSaturdayColor;
	bool FReadOnly;
	TStartOfWeek FStartOfWeek;
	bool FUpdating;
	bool FUseCurrentDate;
	System::AnsiString __fastcall GetCellText(int ACol, int ARow);
	int __fastcall GetDateElement(int Index);
	void __fastcall SetCalWeek(bool NewValue);
	void __fastcall SetCalWeekColor(Graphics::TColor NewValue);
	void __fastcall SetCalendarDate(System::TDateTime Value);
	void __fastcall SetSundayColor(Graphics::TColor NewValue);
	void __fastcall SetSaturdayColor(Graphics::TColor NewValue);
	void __fastcall SetDateElement(int Index, int Value);
	void __fastcall SetStartOfWeek(TStartOfWeek Value);
	void __fastcall SetUseCurrentDate(bool Value);
	bool __fastcall StoreCalendarDate(void);
	
protected:
	virtual void __fastcall Change(void);
	void __fastcall ChangeMonth(int Delta);
	virtual void __fastcall Click(void);
	virtual void __fastcall DrawCell(long ACol, long ARow, const Windows::TRect &ARect, Grids::TGridDrawState 
		AState);
	virtual bool __fastcall SelectCell(long ACol, long ARow);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	
public:
	__fastcall virtual TCalWB(Classes::TComponent* AOwner);
	__property System::TDateTime CalendarDate = {read=FDate, write=SetCalendarDate, stored=StoreCalendarDate
		};
	__property System::AnsiString CellText[int ACol][int ARow] = {read=GetCellText};
	void __fastcall NextMonth(void);
	void __fastcall NextYear(void);
	void __fastcall PrevMonth(void);
	void __fastcall PrevYear(void);
	virtual void __fastcall UpdateCalendar(void);
	
__published:
	__property Align ;
	__property BorderStyle ;
	__property bool CalendarWeek = {read=FCalWeek, write=SetCalWeek, nodefault};
	__property Graphics::TColor CalendarWeekColor = {read=FCalWeekColor, write=SetCalWeekColor, nodefault
		};
	__property Color ;
	__property Ctl3D ;
	__property ColCount ;
	__property int Day = {read=GetDateElement, write=SetDateElement, stored=false, index=1, nodefault};
		
	__property Enabled ;
	__property Font ;
	__property GridLineWidth ;
	__property int Month = {read=GetDateElement, write=SetDateElement, stored=false, index=2, nodefault
		};
	__property ParentColor ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property bool ReadOnly = {read=FReadOnly, write=FReadOnly, default=0};
	__property ShowHint ;
	__property Graphics::TColor SaturdayColor = {read=FSaturdayColor, write=SetSaturdayColor, nodefault
		};
	__property Graphics::TColor SundayColor = {read=FSundayColor, write=SetSundayColor, nodefault};
	__property TStartOfWeek StartOfWeek = {read=FStartOfWeek, write=SetStartOfWeek, nodefault};
	__property TabOrder ;
	__property TabStop ;
	__property bool UseCurrentDate = {read=FUseCurrentDate, write=SetUseCurrentDate, default=1};
	__property Visible ;
	__property bool WeekEndSelectable = {read=FWeekEndSel, write=FWeekEndSel, default=1};
	__property int Year = {read=GetDateElement, write=SetDateElement, stored=false, index=3, nodefault}
		;
	__property OnClick ;
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnStartDrag ;
public:
	/* TCustomGrid.Destroy */ __fastcall virtual ~TCalWB(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TCalWB(HWND ParentWindow) : Grids::TCustomGrid(ParentWindow
		) { }
	
};

struct TCalendarData
{
	bool Enabled;
	bool AutoStart;
	Graphics::TColor Color;
	Classes::THelpContext HelpContext;
	TCalPosition Position;
	Graphics::TColor SaturdayColor;
	TStartOfWeek StartOfWeek;
	Graphics::TColor SundayColor;
	bool WeekOfYear;
	Graphics::TColor WeekOfYearColor;
	bool WeekEndSel;
	System::TDateTime DateValue;
} ;

class __declspec(delphiclass) TCalendarProperties;
class __declspec(pascalimplementation) TCalendarProperties : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FAutoStart;
	bool FEnabled;
	Graphics::TColor FColor;
	Classes::THelpContext FHelpContext;
	TCalPosition FPosition;
	Graphics::TColor FSaturdayColor;
	TStartOfWeek FStartOfWeek;
	Graphics::TColor FSundayColor;
	bool FWeekOfYear;
	Graphics::TColor FWeekOfYearColor;
	bool FWeekEndSel;
	System::TDateTime FValue;
	Classes::TNotifyEvent FOnChange;
	void __fastcall SetEnabled(bool NewValue);
	
protected:
	virtual void __fastcall Changed(void);
	
public:
	__fastcall TCalendarProperties(void);
	__fastcall virtual ~TCalendarProperties(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	TCalendarData __fastcall GetData(void);
	void __fastcall SetData(const TCalendarData &CalendarData);
	__property System::TDateTime DateValue = {read=FValue, write=FValue};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	
__published:
	__property bool Enabled = {read=FEnabled, write=SetEnabled, default=1};
	__property bool AutoStart = {read=FAutoStart, write=FAutoStart, default=0};
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
	__property Classes::THelpContext HelpContext = {read=FHelpContext, write=FHelpContext, nodefault};
	__property TCalPosition Position = {read=FPosition, write=FPosition, default=1};
	__property Graphics::TColor SaturdayColor = {read=FSaturdayColor, write=FSaturdayColor, nodefault};
		
	__property TStartOfWeek StartOfWeek = {read=FStartOfWeek, write=FStartOfWeek, default=0};
	__property Graphics::TColor SundayColor = {read=FSundayColor, write=FSundayColor, nodefault};
	__property bool WeekOfYear = {read=FWeekOfYear, write=FWeekOfYear, default=0};
	__property Graphics::TColor WeekOfYearColor = {read=FWeekOfYearColor, write=FWeekOfYearColor, nodefault
		};
	__property bool WeekEndSelectable = {read=FWeekEndSel, write=FWeekEndSel, default=1};
};

typedef void __fastcall (__closure *TAdjustSize)(int &W, int &H);

class __declspec(delphiclass) TDateEdCal;
class __declspec(pascalimplementation) TDateEdCal : public Forms::TForm
{
	typedef Forms::TForm inherited;
	
__published:
	Extctrls::TBevel* Bevel1;
	Buttons::TSpeedButton* PMSBtn;
	Buttons::TSpeedButton* PYSBtn;
	Stdctrls::TLabel* LabMY;
	Buttons::TSpeedButton* NYSBtn;
	Buttons::TSpeedButton* NMSBtn;
	void __fastcall FormCreate(System::TObject* Sender);
	void __fastcall DispMY(void);
	void __fastcall PMSBtnClick(System::TObject* Sender);
	void __fastcall LabMYDblClick(System::TObject* Sender);
	void __fastcall CalGridDblClick(System::TObject* Sender);
	void __fastcall FormKeyUp(System::TObject* Sender, Word &Key, Classes::TShiftState Shift);
	void __fastcall FormDeactivate(System::TObject* Sender);
	void __fastcall SetDayToLast(void);
	void __fastcall FormShow(System::TObject* Sender);
	void __fastcall PYSBtnClick(System::TObject* Sender);
	void __fastcall FormClose(System::TObject* Sender, Forms::TCloseAction &Action);
	
private:
	Extctrls::TTimer* FRepeatTimer;
	bool FOkTab;
	void __fastcall TimerExpired(System::TObject* Sender);
	
protected:
	void __fastcall DateOper(Word key);
	
public:
	TCalendarData FCalData;
	bool CalWeek;
	System::TDateTime DateSel;
	TSpinDaysIncr IncrementDate;
	bool Ok;
	HWND DateEdHwnd;
	TCalWB* CalGridWB;
public:
	/* TForm.Create */ __fastcall virtual TDateEdCal(Classes::TComponent* AOwner) : Forms::TForm(AOwner
		) { }
	/* TForm.CreateNew */ __fastcall TDateEdCal(Classes::TComponent* AOwner, int Dummy) : Forms::TForm(
		AOwner, Dummy) { }
	/* TForm.Destroy */ __fastcall virtual ~TDateEdCal(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TDateEdCal(HWND ParentWindow) : Forms::TForm(ParentWindow
		) { }
	
};

class __declspec(delphiclass) TStdCtrlDateEd;
class __declspec(pascalimplementation) TStdCtrlDateEd : public Controls::TWinControl
{
	typedef Controls::TWinControl inherited;
	
private:
	Controls::TWinControl* FFocusControl;
	TAdjustSize FAdjustSize;
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	MESSAGE void __fastcall WMGetDlgCode(Messages::TWMNoParams &Message);
	
protected:
	virtual void __fastcall Loaded(void);
	
public:
	__fastcall virtual TStdCtrlDateEd(Classes::TComponent* AOwner);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	
__published:
	__property Align ;
	__property Ctl3D ;
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property Controls::TWinControl* FocusControl = {read=FFocusControl, write=FFocusControl, nodefault
		};
	__property ParentCtl3D ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
public:
	/* TWinControl.CreateParented */ __fastcall TStdCtrlDateEd(HWND ParentWindow) : Controls::TWinControl(
		ParentWindow) { }
	/* TWinControl.Destroy */ __fastcall virtual ~TStdCtrlDateEd(void) { }
	
};

enum dateed_5 { tbFocusRect, tbAllowTimer };

typedef Set<dateed_5, tbFocusRect, tbAllowTimer>  TTimeBtnState;

class __declspec(delphiclass) TTimerSBtnCal;
class __declspec(pascalimplementation) TTimerSBtnCal : public Buttons::TSpeedButton
{
	typedef Buttons::TSpeedButton inherited;
	
private:
	Extctrls::TTimer* FRepeatTimer;
	TTimeBtnState FTimeBtnState;
	void __fastcall TimerExpired(System::TObject* Sender);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	virtual void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	
public:
	__fastcall virtual ~TTimerSBtnCal(void);
	__property TTimeBtnState TimeBtnState = {read=FTimeBtnState, write=FTimeBtnState, nodefault};
public:
		
	/* TSpeedButton.Create */ __fastcall virtual TTimerSBtnCal(Classes::TComponent* AOwner) : Buttons::
		TSpeedButton(AOwner) { }
	
};

class __declspec(delphiclass) TSpBtn;
class __declspec(pascalimplementation) TSpBtn : public TStdCtrlDateEd
{
	typedef TStdCtrlDateEd inherited;
	
private:
	TTimerSBtnCal* FUpButton;
	TTimerSBtnCal* FDownButton;
	TTimerSBtnCal* FFocusedButton;
	Classes::TNotifyEvent FOnUpClick;
	Classes::TNotifyEvent FOnDownClick;
	TTimerSBtnCal* __fastcall CreateButton(void);
	Graphics::TBitmap* __fastcall GetUpGlyph(void);
	Graphics::TBitmap* __fastcall GetDownGlyph(void);
	void __fastcall SetUpGlyph(Graphics::TBitmap* NewValue);
	void __fastcall SetDownGlyph(Graphics::TBitmap* NewValue);
	void __fastcall BtnClick(System::TObject* Sender);
	void __fastcall BtnMouseDown(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState 
		Shift, int X, int Y);
	void __fastcall SetFocusBtn(TTimerSBtnCal* Btn);
	void __fastcall AdjustSize(int &W, int &H);
	HIDESBASE MESSAGE void __fastcall WMSetFocus(Messages::TWMSetFocus &Message);
	HIDESBASE MESSAGE void __fastcall WMKillFocus(Messages::TWMKillFocus &Message);
	
protected:
	virtual void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	
public:
	__fastcall virtual TSpBtn(Classes::TComponent* AOwner);
	
__published:
	__property Graphics::TBitmap* DownGlyph = {read=GetDownGlyph, write=SetDownGlyph, nodefault};
	__property Graphics::TBitmap* UpGlyph = {read=GetUpGlyph, write=SetUpGlyph, nodefault};
	__property Classes::TNotifyEvent OnDownClick = {read=FOnDownClick, write=FOnDownClick};
	__property Classes::TNotifyEvent OnUpClick = {read=FOnUpClick, write=FOnUpClick};
public:
	/* TWinControl.CreateParented */ __fastcall TSpBtn(HWND ParentWindow) : Dateed::TStdCtrlDateEd(ParentWindow
		) { }
	/* TWinControl.Destroy */ __fastcall virtual ~TSpBtn(void) { }
	
};

class __declspec(delphiclass) TCalBtn;
class __declspec(delphiclass) TSpinDateEdit;
class __declspec(pascalimplementation) TSpinDateEdit : public Stdctrls::TCustomEdit
{
	typedef Stdctrls::TCustomEdit inherited;
	
private:
	Graphics::TColor FActivColor;
	Graphics::TColor FSaveColor;
	TAlignment FAlignment;
	TCalendarProperties* FCalendarProperties;
	bool FCalEnabled;
	TCalBtn* FCalBtn;
	TSpBtn* FSpBtn;
	bool FCentury;
	System::AnsiString FDateValue;
	System::AnsiString FDateFormat;
	TDateOrder FDateOrder;
	int FMaxLength;
	bool FInfo;
	TSpinDaysIncr FSpDIncr;
	bool FSpin;
	System::TDateTime FOldValue;
	System::TDateTime FValue;
	Classes::TNotifyEvent FOnBeforeChange;
	Classes::TNotifyEvent FOnSpinDownClick;
	Classes::TNotifyEvent FOnSpinUPClick;
	Classes::TNotifyEvent FOnCalClick;
	Classes::TNotifyEvent FOnCalOpen;
	Classes::TNotifyEvent FOnCalClose;
	TDateOrder __fastcall GetDateOrder(const System::AnsiString DateFormat);
	System::TDateTime __fastcall GetValue(void);
	TCalendarProperties* __fastcall GetCalProp(void);
	void __fastcall SetAlignment(Classes::TAlignment NewValue);
	void __fastcall SetCal(bool NewValue);
	void __fastcall SetSpin(bool NewValue);
	void __fastcall SetEditRect(void);
	void __fastcall SetInfo(bool NewValue);
	void __fastcall SetCentury(bool NewValue);
	void __fastcall SetValue(System::TDateTime NewValue);
	void __fastcall SetDateValue( System::AnsiString NewValue);
	void __fastcall SetCalProp(TCalendarProperties* NewValue);
	void __fastcall SetPosAfterDec(void);
	HIDESBASE System::AnsiString __fastcall ClearSelection( System::AnsiString s, int posA, int posE);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	HIDESBASE MESSAGE void __fastcall CMEnter(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall CMExit(Messages::TWMNoParams &Message);
	MESSAGE void __fastcall WMPaste(Messages::TWMNoParams &Message);
	MESSAGE void __fastcall WMCut(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMTextChanged(Messages::TMessage &Message);
	MESSAGE void __fastcall WMGetDlgCode(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall CMWinIniChange(Messages::TWMWinIniChange &Message);
	
protected:
	MESSAGE void __fastcall WMDateEdCalClose(TWMDateEdCalClose &Message);
	bool __fastcall CheckChar(char key, int PosIns,  System::AnsiString &str);
	void __fastcall InsertChar(char key);
	void __fastcall DeleteChar(Word key);
	virtual void __fastcall CalClick(System::TObject* Sender);
	virtual void __fastcall UpClick(System::TObject* Sender);
	virtual void __fastcall DownClick(System::TObject* Sender);
	void __fastcall SetSel(int SelStart, int SelStop);
	void __fastcall GetSel(int &SelStart, int &SelStop);
	virtual void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual void __fastcall DblClick(void);
	virtual void __fastcall KeyPress(char &Key);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall Reset(void);
	void __fastcall CalPropChanged(System::TObject* Sender);
	
public:
	TDateEdCal* DateEdCal;
	__fastcall virtual TSpinDateEdit(Classes::TComponent* AOwner);
	__fastcall virtual ~TSpinDateEdit(void);
	HIDESBASE void __fastcall Clear(void);
	void __fastcall ResetDate(void);
	
__published:
	__property Graphics::TColor ActiveColor = {read=FActivColor, write=FActivColor, default=-2147483643
		};
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, default=0};
	__property AutoSelect ;
	__property AutoSize ;
	__property BorderStyle ;
	__property TCalendarProperties* CalendarProperties = {read=FCalendarProperties, write=FCalendarProperties
		, nodefault};
	__property bool Century = {read=FCentury, write=SetCentury, default=1};
	__property Color ;
	__property Ctl3D ;
	__property Cursor ;
	__property System::AnsiString DateValue = {read=FDateValue, write=SetDateValue, nodefault};
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property Font ;
	__property Height ;
	__property HelpContext ;
	__property Hint ;
	__property TSpinDaysIncr IncrementDate = {read=FSpDIncr, write=FSpDIncr, default=0};
	__property bool Info = {read=FInfo, write=SetInfo, nodefault};
	__property Left ;
	__property Name ;
	__property ParentCtl3D ;
	__property ParentColor ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ReadOnly ;
	__property ShowHint ;
	__property bool Spin = {read=FSpin, write=SetSpin, nodefault};
	__property TabOrder ;
	__property TabStop ;
	__property Tag ;
	__property Top ;
	__property System::TDateTime Value = {read=GetValue, write=SetValue};
	__property Visible ;
	__property Width ;
	__property Classes::TNotifyEvent OnBeforeChange = {read=FOnBeforeChange, write=FOnBeforeChange};
	__property Classes::TNotifyEvent OnCalClick = {read=FOnCalClick, write=FOnCalClick};
	__property Classes::TNotifyEvent OnCalOpen = {read=FOnCalOpen, write=FOnCalOpen};
	__property Classes::TNotifyEvent OnCalClose = {read=FOnCalClose, write=FOnCalClose};
	__property OnChange ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property Classes::TNotifyEvent OnSpinDownClick = {read=FOnSpinDownClick, write=FOnSpinDownClick};
		
	__property Classes::TNotifyEvent OnSpinUPClick = {read=FOnSpinUPClick, write=FOnSpinUPClick};
	__property OnStartDrag ;
public:
	/* TWinControl.CreateParented */ __fastcall TSpinDateEdit(HWND ParentWindow) : Stdctrls::TCustomEdit(
		ParentWindow) { }
	
};

class __declspec(pascalimplementation) TCalBtn : public TStdCtrlDateEd
{
	typedef TStdCtrlDateEd inherited;
	
private:
	bool FCanCalOn;
	Buttons::TSpeedButton* FCButton;
	Classes::TNotifyEvent FOnClick;
	void __fastcall BtnClick(System::TObject* Sender);
	Graphics::TBitmap* __fastcall GetGlyph(void);
	void __fastcall SetGlyph(Graphics::TBitmap* NewValue);
	void __fastcall AdjustSize(int &W, int &H);
	void __fastcall BtnMouseDown(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState 
		Shift, int X, int Y);
	
public:
	TSpinDateEdit* SpDateEd;
	__fastcall virtual TCalBtn(Classes::TComponent* AOwner);
	
__published:
	__property bool CanCalOn = {read=FCanCalOn, write=FCanCalOn, nodefault};
	__property Graphics::TBitmap* Glyph = {read=GetGlyph, write=SetGlyph, nodefault};
	__property Classes::TNotifyEvent OnClick = {read=FOnClick, write=FOnClick};
public:
	/* TWinControl.CreateParented */ __fastcall TCalBtn(HWND ParentWindow) : Dateed::TStdCtrlDateEd(ParentWindow
		) { }
	/* TWinControl.Destroy */ __fastcall virtual ~TCalBtn(void) { }
	
};

class __declspec(delphiclass) TDBSpinDateEdit;
class __declspec(pascalimplementation) TDBSpinDateEdit : public TSpinDateEdit
{
	typedef TSpinDateEdit inherited;
	
private:
	bool FReadOnly;
	Dbtables::TFieldDataLink* FDataLink;
	bool FFocused;
	Controls::TControlCanvas* FCanvas;
	Graphics::TColor FColor;
	Graphics::TColor FPaintColor;
	bool FParentColor;
	Db::TField* __fastcall GetField(void);
	MESSAGE void __fastcall CMGetDataLink(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall WMPaint(Messages::TWMPaint &Message);
	HIDESBASE void __fastcall SetColor(Graphics::TColor NewValue);
	HIDESBASE void __fastcall SetParentColor(bool NewValue);
	HIDESBASE MESSAGE void __fastcall CMParentColorChanged(Messages::TMessage &Message);
	System::AnsiString __fastcall GetDataField(void);
	Db::TDataSource* __fastcall GetDataSource(void);
	void __fastcall SetDataField(const System::AnsiString NewValue);
	void __fastcall SetDataSource(Db::TDataSource* NewValue);
	void __fastcall SetFocused(bool Value);
	void __fastcall DataChange(System::TObject* Sender);
	HIDESBASE void __fastcall SetValue(System::TDateTime NewValue);
	HIDESBASE MESSAGE void __fastcall WMCut(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall WMPaste(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMEnter(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall CMExit(Messages::TWMNoParams &Message);
	void __fastcall UpdateData(System::TObject* Sender);
	
protected:
	virtual void __fastcall Change(void);
	virtual void __fastcall CalClick(System::TObject* Sender);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual void __fastcall KeyPress(char &Key);
	virtual void __fastcall DownClick(System::TObject* Sender);
	virtual void __fastcall UpClick(System::TObject* Sender);
	
public:
	__fastcall virtual TDBSpinDateEdit(Classes::TComponent* AOwner);
	__fastcall virtual ~TDBSpinDateEdit(void);
	__property Db::TField* Field = {read=GetField, nodefault};
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=-2147483643};
	__property bool ParentColor = {read=FParentColor, write=SetParentColor, default=0};
	__property System::AnsiString DataField = {read=GetDataField, write=SetDataField, nodefault};
	__property Db::TDataSource* DataSource = {read=GetDataSource, write=SetDataSource, nodefault};
public:
		
	/* TWinControl.CreateParented */ __fastcall TDBSpinDateEdit(HWND ParentWindow) : Dateed::TSpinDateEdit(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define str_Vers "DateEditComponent with Calendar-/Spin-Property\r\rCopyrigh"\
	"t (c) 1997 by W. Braun\rVersion 1.5e\reMail Willi_Braun@co"\
	"mpuserve.com"
#define DateDelphi (int)(-657434)
#define DateDelphiMax (int)(2958465)
#define WM_DATEEDCALCLOSE (Word)(1801)
#define InitRepeatPause (Word)(400)
#define RepeatPause (Byte)(100)
extern Word DaysInMonthTable[12];
extern void __fastcall Register(void);
//-- template instantiations -------------------------------------------------
template class TTimeBtnState ;

}	/* namespace Dateed */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Dateed;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// dateed
